<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingSeblod extends JPlugin{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'seblod');
			$this->params = new acyParameter($plugin->params);
		}
		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'SEBLOD';
		$onePlugin->function = 'acymailingseblod_show';
		$onePlugin->help = 'plugin-seblod';
		return $onePlugin;
	}

	function acymailingseblod_show(){
		$config = acymailing_config();
		if($config->get('version') < '5.1.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}
		$lang = JFactory::getLanguage();
		$lang->load('com_cck', JPATH_SITE);
		$lang->load('com_cck_default', JPATH_SITE);
		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.seblod';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->contentorderdir = $app->getUserStateFromRequest($paramBase.".contentorderdir", 'contentorderdir', 'DESC', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->clickable = $app->getUserStateFromRequest($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = $app->getUserStateFromRequest($paramBase.".clickableauto", 'clickableauto', '1', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');

		$searchFields = array('a.id', 'a.title', 'b.title', 'c.username');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE ".$this->db->Quote($searchVal)." OR ", $this->db->Quote($searchFields))." LIKE ".$this->db->Quote($searchVal);
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.state = 1";
		}else{
			$filters[] = "a.state != -2";
		}

		//we load all articles with the categories
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,c.*,a.id AS gID, a.title AS gtitle FROM `#__content` AS a ';
		$query .= 'JOIN #__categories AS b ON a.catid = b.id ';
		$query .= 'LEFT JOIN `#__users` AS c ON a.created_by = c.id';
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()){
			$my = JFactory::getUser();
			$filters[] = "a.created_by = ".intval($my->id);
		}
		//if a category is selected
		if(!empty($pageInfo->filter_cat)) $filters[] = "a.catid = ".intval($pageInfo->filter_cat);
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$this->db->Quote($pageInfo->filter->order->value).' '.$this->db->Quote($pageInfo->filter->order->dir);

		$this->db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $this->db->loadObjectList();
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search, $rows);

		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);
		$type = JRequest::getString('type');
		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbaffiche.length; i++){
					if(document.adminForm.cbaffiche[i].checked){
						if(tmp == 0){
							otherinfo += '|displays:' + document.adminForm.cbaffiche[i].value;
							tmp++;
						}else{
							otherinfo += '; ' + document.adminForm.cbaffiche[i].value;
						}
					}
				}
				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked){
						otherinfo += '|clickable:' + document.adminForm.clickable[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '|pict:' + document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{Seblod:' + i + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('catall').className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('catall').className = 'selectedrow';
						var key;
						for(key in selectedCat){
							if(isNaN(key)) continue;
							window.document.getElementById('cat' + key).className = rowClass;
							delete selectedCat[key];
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTagAuto(){
				var otherinfo = '';
				var tmp = 0;
				for(var i = 0; i < document.adminForm.cbafficheauto.length; i++){
					if(document.adminForm.cbafficheauto[i].checked){
						if(tmp == 0){
							otherinfo += '|displays:' + document.adminForm.cbafficheauto[i].value;
							tmp++;
						}else{
							otherinfo += '; ' + document.adminForm.cbafficheauto[i].value;
						}
					}
				}
				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked){
						otherinfo += '|clickable:' + document.adminForm.clickableauto[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						otherinfo += '|pict:' + document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '|maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}
				if(document.adminForm.max_article.value){
					otherinfo += "|max_article:" + document.adminForm.max_article.value;
				}
				if(document.adminForm.cols.value){
					otherinfo += "|cols:" + document.adminForm.cols.value;
				}

				if(document.adminForm.contentorder.value){
					otherinfo += "|order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}

				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){
					otherinfo += "|min_article:" + document.adminForm.min_article.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					otherinfo += document.adminForm.contentfilter.value;
				}
				<?php } ?>

				var tag = '{autoSeblod:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';
				setTag(tag);
			}
			//-->
		</script>
		<?php
		//we load all fields to list them, so the user can choose them
		$query = 'SELECT a.name, a.title '.'FROM `#__cck_core_fields` AS a '.'WHERE a.published = 1 '.'AND (a.storage LIKE "custom" '.'OR a.storage_table LIKE "#__cck_store_item_content" '.'OR a.storage_field LIKE "introtext" '.'OR a.folder = 1) '.'ORDER BY a.title';
		$this->db->setQuery($query);
		$fields = $this->db->loadObjectList();

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}
		$clickable = array();
		$clickable[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$clickable[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('seblod_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'seblod_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY'); ?></td>
				<td><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('ACY_TITLE'); ?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="introtext" id="introtext" onclick="updateTag();"/><label style="margin-left:5px" for="introtext" id="introtext-lbl"><?php echo JText::_('INTRO_TEXT'); ?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="fulltext" id="fulltext" onclick="updateTag();"/><label style="margin-left:5px" for="fulltext" id="fulltext-lbl"><?php echo JText::_('FULL_TEXT'); ?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="created" id="created" onclick="updateTag();"/><label style="margin-left:5px" for="created" id="created-lbl"><?php echo JText::_('CREATED_DATE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td><input type="checkbox" name="cbaffiche" value="pubdate" id="pubdate" onclick="updateTag();"/><label style="margin-left:5px" for="pubdate" id="pubdate-lbl"><?php echo JText::_('COM_CCK_SHOW_PUBLISH_DATE'); ?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="image" id="image" onclick="updateTag();"/><label style="margin-left:5px" for="image" id="image-lbl"><?php echo JText::_('ACY_IMAGE'); ?></label></td>
				<?php
				$tmp = 2;
				if(!empty($fields)){
					foreach($fields as $onefield){
						if(in_array($onefield->name, array('art_introtext', 'art_fulltext', 'cat_description'))) continue;
						if($tmp != 4){
							echo '<td><input type="checkbox" name="cbaffiche" value="'.$onefield->name.'" id="'.$onefield->name.'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$onefield->name.'" id="'.$onefield->name.'-lbl">'.$onefield->title.'</label></td>';
						}else{
							echo '</tr><tr><td/><td><input type="checkbox" name="cbaffiche" value="'.$onefield->name.'" id="'.$onefield->name.'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$onefield->name.'" id="'.$onefield->name.'-lbl">'.$onefield->title.'</label></td>';
							$tmp = 0;
						}
						$tmp++;
					}
				}
				while($tmp != 4){
					echo '<td/>';
					$tmp++;
				}
				?>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('CREATED_DATE'), 'a.created', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for($i = 0; $i < count($rows); $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->gID; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->gID.",'row$k'" ?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->gtitle;
						$text .= '<br /><b>'.JText::_('ACY_USERNAME', true).' : </b>'.$row->username;
						echo acymailing_tooltip($text, $row->gtitle, '', $row->gtitle);
						?>
					</td>
					<td>
						<?php if(strpos($row->created, ': ') != false){
							$arti = str_replace('/', '', strrchr(strip_tags($row->created), '/'));
							echo $arti;
						}else{
							echo $row->created;
						}
						?>
					</td>
					<td>
						<?php
						if(!empty($row->title)){
							$text = '<b>'.JText::_('TAG_CATEGORIES', true).' : </b>'.$row->title;
							echo acymailing_tooltip($text, $row->title, '', $row->title);
						}
						?>
					</td>
					<td align="center" style="text-align:center">
						<?php echo $row->gID; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'seblod_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%">
			<tr>
				<table width="100%" class="adminform">
					<tr>
						<td><?php echo JText::_('DISPLAY'); ?></td>
						<td><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="title-lbl"><?php echo JText::_('ACY_TITLE'); ?></label></td>
						<td><input type="checkbox" name="cbafficheauto" value="introtext" id="introtextauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="introtextauto" id="introtextauto-lbl"><?php echo JText::_('INTRO_TEXT'); ?></label></td>
						<td><input type="checkbox" name="cbafficheauto" value="fulltext" id="fulltextauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="fulltextauto" id="fulltextauto-lbl"><?php echo JText::_('FULL_TEXT'); ?></label></td>
						<td><input type="checkbox" name="cbafficheauto" value="created" id="createdauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="createdauto" id="created-lbl"><?php echo JText::_('CREATED_DATE'); ?></label></td>
					</tr>
					<tr>
						<td/>
						<td><input type="checkbox" name="cbafficheauto" value="pubdate" id="pubdateauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="pubdateauto" id="pubdateauto-lbl"><?php echo JText::_('COM_CCK_SHOW_PUBLISH_DATE'); ?></label></td>
						<td><input type="checkbox" name="cbaffiche" value="image" id="imageauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="imageauto" id="imageauto-lbl"><?php echo JText::_('ACY_IMAGE'); ?></label></td>
						<?php
						$tmp = 2;
						if(!empty($fields)){
							foreach($fields as $onefield){
								if($onefield->name != 'art_introtext' && $onefield->name != 'art_fulltext' && $onefield->name != 'cat_description'){
									if($tmp != 4){
										echo '<td><input type="checkbox" name="cbafficheauto" value="'.$onefield->name.'" id="'.$onefield->name.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$onefield->name.'auto" id="'.$onefield->name.'-lbl">'.$onefield->title.'</label></td>';
									}else{
										echo '</tr><tr><td/><td><input type="checkbox" name="cbafficheauto" value="'.$onefield->name.'" id="'.$onefield->name.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$onefield->name.'auto" id="'.$onefield->name.'-lbl">'.$onefield->title.'</label></td>';
										$tmp = 0;
									}
									$tmp++;
								}
							}
						}
						while($tmp != 4){
							echo '<td/>';
							$tmp++;
						}
						?>
					</tr>
				</table>
			</tr>
			<tr>
				<table width="100%" class="adminform">
					<tr>
						<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
						<td valign="top" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $clickable, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
						<td valign="top">
							<?php echo JText::_('DISPLAY_PICTURES'); ?>
						</td>
						<td><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
							<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
								<?php echo JText::_('CAPTCHA_WIDTH') ?>
								<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
								<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
						</td>
					</tr>
					<tr>
						<td valign="top"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
						<td colspan="4">
							<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:50px;"', 'value', 'text', $pageInfo->contentorder); ?>
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('MAX_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="max_article" style="width:75px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
						</td>
						<td/>
						<td>
							<?php echo JText::_('ACY_ORDER'); ?>
						</td>
						<td>
							<?php
							$values = array('id' => 'ACY_ID', 'created' => 'CREATED_DATE', 'modified' => 'MODIFIED_DATE', 'title' => 'FIELD_TITLE');
							echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
							?>
						</td>
					</tr>
					<?php if($type == 'autonews'){ ?>
						<tr>
							<td>
								<?php echo JText::_('MIN_ARTICLE'); ?>
							</td>
							<td>
								<input type="text" name="min_article" style="width:75px" value="1" onchange="updateTagAuto();"/>
							</td>
							<td/>
							<td style="width:100px">
								<?php echo JText::_('JOOMEXT_FILTER'); ?>
							</td>
							<td>
								<?php $filter = acymailing_get('type.contentfilter');
								$filter->onclick = 'updateTagAuto();';
								echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
							</td>
						</tr>
					<?php } ?></table>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<tr id="catall" class="<?php echo "row0"; ?>" onclick="applyAuto('all','<?php echo "row0" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td><?php echo JText::_('ACY_ALL'); ?></td>
			</tr>
			<?php $k = 1;
			if(!empty($this->catvalues)){
				foreach($this->catvalues as $oneCat){
					if(empty($oneCat->value)) continue;
					?>
					<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->text;
							?>
						</td>
					</tr>
					<?php $k = 1 - $k;
				}
			} ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT id,parent_id,title,extension FROM #__categories WHERE extension = "com_content" ORDER BY `id` DESC');
		$mosetCats = $this->db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats)){
			foreach($mosetCats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parent_id = 1, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			//we remove the ROOT category
			if($cat->title != "ROOT" && $cat->extension == "com_content") $this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
			$this->_handleChildrens($cat->id, $level + 1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){
		$tags = $this->acypluginsHelper->extractTags($email, 'Seblod');
		if(empty($tags)) return;

		require_once(JPATH_SITE.DS.'plugins'.DS.'content'.DS.'cck'.DS.'cck.php');
		require_once(JPATH_SITE.DS.'plugins'.DS.'acymailing'.DS.'seblod'.DS.'acyseblodfield.php');

		//let's determine the Itemid
		$menuid = $this->params->get('itemid');
		if(empty($menuid)){
			$this->db->setQuery('SELECT id FROM #__menu WHERE link LIKE "%index.php?option=com_content&view=article%" LIMIT 1');
			$menuid = $this->db->loadResult();
		}
		$this->itemId = empty($menuid) ? '' : '&Itemid='.$menuid;

		$lang = JFactory::getLanguage();
		$lang->load('com_cck_default', JPATH_SITE);

		$this->addedcss = false;

		if(!empty($email->language)){
			$this->db->setQuery('SELECT lang_id, lang_code FROM #__languages WHERE sef = '.$this->db->quote($email->language).' LIMIT 1');
			$this->newslanguage = $this->db->loadObject();
		}

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceContent(&$tag){
		$app = JFactory::getApplication();
		if(!empty($tag->displays)) $tag->displays = explode(';', $tag->displays);
		foreach($tag->displays as $i => $oneField){
			$tag->displays[$i] = trim($oneField);
		}
		//2 : Load the Seblod article
		$query = 'SELECT a.*,b.alias AS catalias,c.name AS username FROM #__content AS a ';
		$query .= 'JOIN #__categories AS b ON a.catid = b.id ';
		$query .= 'LEFT JOIN #__users AS c ON a.created_by = c.id ';
		$query .= 'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$this->db->setQuery($query);
		$article = $this->db->loadObject();
		$result = '';
		$varFields = array();

		//In case of we could not load the article for any reason
		if(empty($article)){
			if($app->isAdmin()) $app->enqueueMessage('The article "'.$tag->id.'" could not be loaded', 'notice');
			return $result;
		}

		$link = 'index.php?option=com_content&view=article&id='.$article->id.'&catid='.$article->catid.''.$this->itemId;
		$varFields['{link}'] = $link;
		$resultTitle = $article->title;
		$created = '';
		//create a clickable title or a simple title
		if(in_array('title', $tag->displays)){
			if(!empty($tag->clickable)) $resultTitle = '<a href="'.$link.'" target="_blank" >'.$resultTitle.'</a>';
			$resultTitle = '<tr><td colspan="2"><h2 class="acymailing_title">'.$resultTitle.'</h2></td></tr>';
		}
		$varFields['{created}'] = acymailing_getDate(acymailing_getTime($article->created), JText::_('DATE_FORMAT_LC'));
		if(in_array('created', $tag->displays)) $created = '<tr><td>'.JTEXT::_('CREATED_DATE').' : </td><td>'.$varFields['{created}'].'</td></tr>';

		$pubdate = '';
		$varFields['{pubdate}'] = acymailing_getDate(acymailing_getTime($article->publish_up), JText::_('DATE_FORMAT_LC'));
		if(in_array('pubdate', $tag->displays)) $pubdate = '<tr><td>'.JTEXT::_('ACY_PUBLISHED').' : </td><td>'.$varFields['{pubdate}'].'</td></tr>';

		$fields = explode('<br />', $article->introtext);
		$answer = array();
		foreach($fields as $oneField){
			$fieldDetail = explode('::', $oneField);
			if(!empty($fieldDetail[1]) && !empty($fieldDetail[1])) $answer[$fieldDetail[1]] = $fieldDetail[2];
		}
		$description = '';

		if(ACYMAILING_J16 && in_array('image', $tag->displays) && !empty($article->images) && !empty($tag->pict)){
			$images = json_decode($article->images);
			$pictVar = 'image_intro';
			if(empty($images->$pictVar)) $pictVar = 'image_fulltext';
			if(!empty($images->$pictVar)){
				$varFields['{picthtml}'] = '<img style="float:left;padding-right:10px;padding-bottom:10px;" alt="" border="0" src="'.JURI::root().$images->$pictVar.'" />';
				$article->introtext = $varFields['{picthtml}'].$article->introtext;
				$answer['introtext'] = $varFields['{picthtml}'].$answer['introtext'];
			}
		}

		if(in_array('introtext', $tag->displays) && !empty($answer['introtext'])){
			$varFields['{introtext}'] = $answer['introtext'];
			$description .= '<tr><td colspan="2">'.$answer['introtext'].'</td></tr>';
		}
		if(in_array('fulltext', $tag->displays) && !empty($answer['fulltext'])){
			$varFields['{fulltext}'] = $answer['fulltext'];
			$description .= '<tr><td colspan="2">'.$answer['fulltext'].'</td></tr>';
		}
		//this is the description
		$article->text = $article->introtext.$article->fulltext;

		$params = array();
		$acyCCK = new AcyplgContentCCK();
		$acyCCK->acyDisplays = $tag->displays;
		$acyCCK->onContentPrepare('com_content.article', $article, $params, 0);

		foreach($article as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		$result .= $article->text;

		//if there are parameters from seblod in the description, we do not display it
		if(strlen(strip_tags($description)) < 3) $description = '';

		//we add all informations in a table
		$result = '<div class="acymailing_content" style="clear:both"><table cellspacing="0" cellpadding="5" border="0" style="width:100%;">'.$resultTitle.$description.$created.$pubdate.'<tr><td colspan="2">'.$result.'</td></tr></table></div>';
		$result = preg_replace('#administrator/#', '', $result);

		$result = str_replace('&nbsp;', ' ', $result);
		$result = preg_replace('#<iframe[^>]*(http[^"]*embed/)([^"]*)[^<]*</iframe>#', '<a href="$1$2" target="_blank"><img src="http://img.youtube.com/vi/$2/1.jpg"/></a>', $result);
		$result = str_replace('/embed/', '/watch?v=', $result);

		//if the user created a custom template
		if(!empty($tag->tmpl) && file_exists(ACYMAILING_MEDIA.'plugins'.DS.'seblod_'.$tag->tmpl.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'seblod_'.$tag->tmpl.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}elseif(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'seblod.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'seblod.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}


		if(!$this->addedcss){
			$result .= '<style type="text/css">
							div.cck_value, div.cck_label {
								vertical-align: top;
								display: inline-block;
							}

							div.cck_label {
								min-width: 50px;
							}
							</style>';
			$this->addedcss = true;
		}

		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'autoSeblod');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}
			$query = 'SELECT id FROM #__content';
			$where = array();
			if(!empty($parameter->filter)){
				if($parameter->filter == 'modify'){
					$where[] = 'modified > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' OR created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'created'){
					$where[] = 'created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			if(!empty($selectedArea)) $where[] = 'catid IN ('.implode(',', $selectedArea).')';

			$where[] = "state = 1";
			$query .= ' WHERE ('.implode(') AND (', $where).')';
			if(!empty($parameter->order)){
				$ordering = explode(',', $parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max_article)){
				$query .= ' LIMIT '.intval($parameter->max_article);
			}elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';

			//We add a limit for the preview otherwise we could break everything
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);
			if(!empty($parameter->min_article) && count($allArticles) < $parameter->min_article){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}
			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoseblod.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autoseblod.php');
					$stringTag = ob_get_clean();
				}else{
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'Seblod:'.$oneArticleId;
						if(!empty($parameter->displays)) $args[] = 'displays:'.$parameter->displays;
						if(!empty($parameter->clickable)) $args[] = 'clickable:'.$parameter->clickable;
						if(isset($parameter->tmpl)) $args[] = 'tmpl:'.$parameter->tmpl;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass